unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, StdCtrls, Spin, Sockets, xmldom, XMLIntf, msxmldom, XMLDoc,
  ComCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    IdHTTP: TIdHTTP;
    lstFrom: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    lstTo: TComboBox;
    Button1: TButton;
    spnConnections: TSpinEdit;
    Label3: TLabel;
    dfgfdgfs: TLabel;
    lstOver: TComboBox;
    Label5: TLabel;
    spn: TSpinEdit;
    XMLDocument: TXMLDocument;
    edtTime: TEdit;
    Label4: TLabel;
    lstConnections: TListBox;
    Label6: TLabel;
    lstTrains: TListBox;
    Label7: TLabel;
    Label8: TLabel;
    lstStations: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure lstConnectionsClick(Sender: TObject);
    procedure lstTrainsClick(Sender: TObject);
  private
    adress: string;  //http adresa serveru
    connections: array of IXMLNode;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var StationsStream: TStream;  //stream kam se ulozi xml z localhost/SeznamStanic
                              //aby se mohlo nacist do komponenty xmlDocument
    i: integer;
begin
  adress := InputBox('Adresa', 'Zadejte http adresu serveru (bez lomitka na konci)',
                  'http://localhost');    //zadani http adresy
  idHttp.Port := StrToInt(InputBox('Port', 'Zadejte slo portu na kterm se m'+      //zadani portu
                                            'tenhle vtvor spojit se serverem',
                                            '80'));

  //----- Nacteni seznamu stanic do xml ----------------------------------------
  StationsStream := TMemoryStream.Create;  //vytvoreni streamu
  idHttp.Get('http://localhost/SeznamStanic', StationsStream);  //nacteni seznamu stanic do streamu
  StationsStream.Seek(0, soFromBeginning);  //skok na zacatek streamu
  XmlDocument.LoadFromStream(StationsStream);  //nacteme do komponenty xmldocument xml ze streamu
  StationsStream.Free; //uvolnime po streamu pamet
  //----------------------------------------------------------------------------

  //------------- Vypsani seznamu stanic do listboxu ---------------------------
  XmlDocument.Active := true;   //aktivace xmlDocument
  //vypsani vsech stanic
  for i:=1 to xmlDocument.DocumentElement.ChildNodes.Count-1 do begin
    lstFrom.Items.Add(xmldocument.DocumentElement.ChildNodes.Get(i).NodeValue);
  end;
  //pridani seznamu do zbylych listboxu a nastaveni vychozich hodnot
  lstFrom.ItemIndex := 0;
  lstTo.Items := lstFrom.Items;
  lstTo.ItemIndex := 1;
  lstOver.Items.AddStrings(lstFrom.Items);
  //----------------------------------------------------------------------------

end;

procedure TForm1.Button1Click(Sender: TObject);
var StationsStream: TStream;  //stream kam se ulozi xml z localhost/NajdiSpojeni
                              //aby se mohlo nacist do komponenty xmlDocument
    i, j: integer;
    params: string;  //v teto promenne budou ulozeny parametry uvedene za http adresou a ?
    item: string;  //polozka, ktera bude pridana do lstConnections
    last: IXMLNode;
begin

  //--------------- vytvoreni parametru ----------------------------------------
  params:='odkud='+lstFrom.Text+
          '&kam='+lstTo.Text+
          '&prestupy='+IntToStr(spn.Value)+
          '&spojeni='+IntToStr(spnConnections.Value);

  if lstOver.ItemIndex <> 0 then
    params := params + '&pres='+lstOver.Text;

  if edtTime.Text<>'' then
    params := params + '&odjezd='+edtTime.Text;
  //----------------------------------------------------------------------------


  //----- Nacteni vysledku pozadavku stanic do xml -----------------------------
  StationsStream := TMemoryStream.Create;  //vytvoreni streamu
  idHttp.Get(adress+'/NajdiSpojeni?'+params, StationsStream);  //nacteni seznamu stanic do streamu
  StationsStream.Seek(0, soFromBeginning);  //skok na zacatek streamu
  XmlDocument.LoadFromStream(StationsStream);  //nacteme do komponenty xmldocument xml ze streamu
  StationsStream.Free; //uvolnime po streamu pamet
  //----------------------------------------------------------------------------

  //------------- Vypsani seznamu spojeni do listboxu ---------------------------
  XmlDocument.Active := true;   //aktivace xmlDocument
  lstConnections.Items.Text := '';
  //vypsani vsech spojeni
  SetLength(Connections, xmlDocument.DocumentElement.ChildNodes.Count); //rozsah pole nastavime na pocet spojeni
  //projedem vsechny spojeni a hodime do listboxu lstConnections
  for i:=0 to xmlDocument.DocumentElement.ChildNodes.Count-1 do begin
    Connections[i] := xmldocument.DocumentElement.ChildNodes.Get(i);
    item := intToStr(i+1);
    item := item + ' ' + Connections[i].ChildNodes.First.ChildNodes.First.GetAttributeNS('odjezd', '');
    for j:=0 to Connections[i].ChildNodes.Last.ChildNodes.Count-1 do begin
      if Connections[i].ChildNodes.Last.ChildNodes.get(j).NodeName = 'Stanice' then
        last := Connections[i].ChildNodes.Last.ChildNodes.get(j);
    end;
    item := item + '-' + last.GetAttributeNS('prijezd', '');
    lstConnections.Items.Add(Item);
  end;
  PageControl1.SelectNextPage(true);

end;

procedure TForm1.lstConnectionsClick(Sender: TObject);
var i: integer;
begin
 lstTrains.Items.Text:='';
 //projedeme vsechny spojeni (pole Connections) a do listboxu lstTrains hodime cisla vlaku
 for i:=0 to Connections[lstConnections.ItemIndex].ChildNodes.Count-1 do begin
    //z nodu linka dostanem atribut cislo  
    lstTrains.Items.Add(Connections[lstConnections.ItemIndex].ChildNodes.get(i).GetAttributeNS('cislo',''));
 end;
end;

procedure TForm1.lstTrainsClick(Sender: TObject);
var SelectedConnection, SelectedTrain: IXMLNode; //tyto promenne jsou zde kvuli zkraceni zapisu
    i: integer;
    item: string;
begin
  lstStations.Items.Text := '';
  // do selected connection hodime vsechny vlaky spojeni vybraneho v lstConnections
  SelectedConnection := Connections[lstConnections.ItemIndex].ChildNodes.Get(lstTrains.ItemIndex);
  // projedem vsechny vlaky...
  for i:=0 to SelectedConnection.ChildNodes.Count-1 do begin
    // do selectedtrain hodime vsechny stanice a poznamky vlaku vybraneho v lstTrains
    SelectedTrain := SelectedConnection.ChildNodes.Get(i);

    // pokud se aktualni node jmenuje stanice...
    if selectedtrain.NodeName = 'Stanice' then begin
      //pokud ma atribut prijezd -> zapiseme do item
      if SelectedTrain.HasAttribute('odjezd') then
        item:=SelectedTrain.GetAttributeNS('prijezd', '')
      else
        item:='     ';  //jinak vynechame mezery kvuli formatovani
      //pokud ma atribut odjezd -> zapiseme do item
      if SelectedConnection.ChildNodes.Get(i).HasAttribute('prijezd') then
        item := item + '  ' + SelectedTrain.GetAttributeNS('prijezd', '')
      else
        item:='     ';  //jinak vynechame mezery kvuli formatovani
      item := item + '  stanice: ' + SelectedTrain.NodeValue; //zapiseme jmeno stanice
    //pokud se node nejmenuje stanice -> poznamka - item bude poznamka
    end else
      item:='poznmka: '+SelectedTrain.NodeValue;

    lstStations.Items.Add(item); //pridame polozku item do seznamu
  end;
end;

end.
